#include <v8.h>
#include <node.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "libstemmer/include/libstemmer.h"

#define LIMIT 12

using namespace v8;
using namespace node;

Handle<Value> StemEn(const Arguments& args) {
    if (args.Length() == 0 || !args[0]->IsString())
        return Boolean::New(false);

    static sb_stemmer * stemmer = sb_stemmer_new("en", NULL);

    //Get the word
    char * word = (char *) malloc(LIMIT * sizeof(char));
    args[0]->ToString()->WriteUtf8(word);

    //Stem the word
    const sb_symbol *stemmed = sb_stemmer_stem(stemmer, (const sb_symbol *) word, strlen(word));
    Local<String> result = String::New((char *) stemmed);
    free(word);

    return result;
}

extern "C" void init(Handle<Object> target) {
  HandleScope scope;
  NODE_SET_METHOD(target, "stem", StemEn);
}
